#=
Created on 07 Oct 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 56 of Project Euler
https://projecteuler.net/problem=56
=#

using BenchmarkTools

function Problem56()
    #=
    A googol (10^100) is a massive number: one followed by one-hundred zeros;
    100100 is almost unimaginably large: one followed by two-hundred zeros.
    Despite their size, the sum of the digits in each number is only 1.

    Considering natural numbers of the form, a^b, where a, b < 100, what is the
    maximum digital sum?
    =#

    ans = 0
    for a in 1:100
        for b in 1:100
            num = sum(digits(big(a)^b))
            if num > ans
                ans = num
            end
        end
    end

    return ans
end


println("Time to evaluate Problem $(lpad(56, 3, "0")):")
@btime Problem56()
println("")
println("Result for Problem $(lpad(56, 3, "0")): ", Problem56())
