#=
Created on 08 Jun 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 002 of Project Euler
https://projecteuler.net/problem=2
=#

using BenchmarkTools

function Problem002()
    #=
    Each new term in the Fibonacci sequence is generated by adding the
    previous two terms. By starting with 1 and 2, the first 10 terms will be:

        1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...

    Find the sum of all the even-valued terms in the sequence which do not
    exceed four million.
    =#

    ans = 0
    limit = 4_000_000
    x, y = 1, 1
    # Because every third Fibonacci number is even
    z = x + y
    while z <= limit
        ans += z
        x = y + z
        y = z + x
        z = x + y
    end

    return ans
end


println("Took: ")
@btime Problem002()
println("")
println("Result for Problem $(lpad(2, 3, "0")): ", Problem002())
