#=
Created on 17 Jun 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 004 of Project Euler
https://projecteuler.net/problem=4
=#

using BenchmarkTools


ispalindrome(x::Integer, numdigits = ndigits(x)) = _ispalindrome(x, 10^(numdigits - 2))
function _ispalindrome(x::Integer, divider)
    x < 10 && return iszero(x) || iszero(divider)
    (x, digit1) = divrem(x, 10)
    (digit2, x) = divrem(x, divider)

    return digit1 == digit2 && _ispalindrome(x, div(divider, 100))
end


function Problem004()
    #=
    A palindromic number reads the same both ways. The largest palindrome made
    from the product of two 2-digit numbers is 9009 = 91 x 99.

    Find the largest palindrome made from the product of two 3-digit numbers.
    =#

    ans = 10_001
    for i = 100:999, j = i:999
        num = i * j
        if ((num > ans) && ispalindrome(num, ndigits(num)))
            ans = num
        end
    end

    return ans
end


println("Took:")
@btime Problem004()
println("")
println("Result for Problem $(lpad(4, 3, "0")): ", Problem004())
