#=
Created on 28 Jul 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 17 of Project Euler
https://projecteuler.net/problem=17
=#

using BenchmarkTools

function num2letters(num, nums)
    if num <= 20
        return nums[num]
    elseif num < 100
        tens, units = divrem(num, 10)
        return (nums[tens*10] + num2letters(units, nums))
    elseif num < 1000
        hundreds, rest = divrem(num, 100)
        if rest != 0
            return (
                num2letters(hundreds, nums) +
                nums[100] +
                length("and") +
                num2letters(rest, nums)
            )
        else
            return (num2letters(hundreds, nums) + nums[100])
        end
    else
        thousands, rest = divrem(num, 1000)
        return (num2letters(thousands, nums) + nums[1000])
    end
end

function Problem017()
    #=
    If the numbers 1 to 5 are written out in words: one, two, three, four,
    five, then there are 3 + 3 + 5 + 4 + 4 = 19 letters used in total.

    If all the numbers from 1 to 1000 (one thousand) inclusive were written
    out in words, how many letters would be used?

    NOTE: Do not count spaces or hyphens. For example, 342 (three hundred and
    forty-two) contains 23 letters and 115 (one hundred and fifteen) contains
    20 letters. The use of "and" when writing out numbers is in compliance
    with British usage.
    =#

    nums = Dict(
            0 => 0,
            1 => 3,
            2 => 3,
            3 => 5,
            4 => 4,
            5 => 4,
            6 => 3,
            7 => 5,
            8 => 5,
            9 => 4,
            10 => 3,
            11 => 6,
            12 => 6,
            13 => 8,
            14 => 8,
            15 => 7,
            16 => 7,
            17 => 9,
            18 => 8,
            19 => 8,
            20 => 6,
            30 => 6,
            40 => 5,
            50 => 5,
            60 => 5,
            70 => 7,
            80 => 6,
            90 => 6,
            100 => 7,
            1000 => 8,
    )
    n = 1000
    letters = 0
    for num = 1:n
        letters += num2letters(num, nums)
    end
    return letters
end


println("Took:")
@btime Problem017()
println("")
println("Result for Problem $(lpad(17, 3, "0")): ", Problem017())
