#=
Created on 02 Aug 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 019 of Project Euler
https://projecteuler.net/problem=19
=#

using BenchmarkTools
using Dates

function Problem019()
    #=
    You are given the following information, but you may prefer to do some
    research for yourself.

    1 Jan 1900 was a Monday.
    Thirty days has September, April, June and November.
    All the rest have thirty-one,
    Saving February alone,
    Which has twenty-eight, rain or shine.
    And on leap years, twenty-nine.
    A leap year occurs on any year evenly divisible by 4, but not on a century
    unless it is divisible by 400.

    How many Sundays fell on the first of the month during the twentieth
    century (1 Jan 1901 to 31 Dec 2000)?
    =#

    ans = 0
    for year = 1901:2000
        for month = 1:12
            if Dates.dayofweek(Date(year, month, 1)) == Dates.Sunday
                ans += 1
            end
        end
    end

    return ans
end


println("Took:")
@btime Problem019()
println("")
println("Result for Problem $(lpad(19, 3, "0")): ", Problem019())
