#=
Created on 05 Aug 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 021 of Project Euler
https://projecteuler.net/problem=21
=#

using BenchmarkTools
using Primes


function sum_divisors(n)
    counter = 1
    factors = factor(n)
    factors_keys = keys(factors)

    for i in factors_keys
        count = 1
        for j = 1:factors[i]
            count += i^j
        end
        counter *= count
    end
    return counter - n
end


function is_amicable(n)
    s = sum_divisors(n)
    if s == n
        return false
    end

    sum_s = sum_divisors(s)
    if sum_s == n
        return true
    end
    return false
end


function Problem021()
    #=
    Let d(n) be defined as the sum of proper divisors of n (numbers
    less than n which divide evenly into n).
    If d(a) = b and d(b) = a, where a ≠ b, then a and b are an amicable
    pair and each of a and b are called amicable numbers.

    For example, the proper divisors of 220 are 1, 2, 4, 5, 10, 11, 20, 22,
    44, 55 and 110; therefore d(220) = 284. The proper divisors of 284 are
    1, 2, 4, 71 and 142; so d(284) = 220.

    Evaluate the sum of all the amicable numbers under 10000
    =#

    # ans = 0
    # for i = 2:10_000
    #     if is_amicable(i)
    #         ans += i
    #     end
    # end

    # return ans
    ans = sum(i for i in 2:10_000 if is_amicable(i))
    return ans
end


println("Took:")
@btime Problem021()
println("")
println("Result for Problem $(lpad(21, 3, "0")): ", Problem021())
