#=
Created on 13 Aug 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 24 of Project Euler
https://projecteuler.net/problem=24 =#

using BenchmarkTools
using Combinatorics

function Problem024()
    #=
    A permutation is an ordered arrangement of objects. For example, 3124 is
    one possible permutation of the digits 1, 2, 3 and 4. If all of the
    permutations are listed numerically or alphabetically, we call it
    lexicographic order. The lexicographic permutations of 0, 1 and 2 are:

                    012   021   102   120   201   210

    What is the millionth lexicographic permutation of the digits
    0, 1, 2, 3, 4, 5, 6, 7, 8 and 9?
    =#

    digits = collect(0:9)
    _permutations = nthperm(digits, 1_000_000)
    return join(_permutations)
end


println("Took:")
@btime Problem024()
println("")
println("Result for Problem $(lpad(24, 3, "0")): ", Problem024())
