#=
Created on 15 Aug 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 25 of Project Euler
https://projecteuler.net/problem=25 =#

using BenchmarkTools

function Problem25()
    #=
    The Fibonacci sequence is defined by the recurrence relation:

        Fn = Fn−1 + Fn−2, where F1 = 1 and F2 = 1.

    Hence the first 12 terms will be:

        F1 = 1
        F2 = 1
        F3 = 2
        F4 = 3
        F5 = 5
        F6 = 8
        F7 = 13
        F8 = 21
        F9 = 34
        F10 = 55
        F11 = 89
        F12 = 144

    The 12th term, F12, is the first term to contain three digits.

    What is the index of the first term in the Fibonacci sequence to
    contain 1000 digits? =#
    a, b = 1, 1
    index = 2

    while length(digits(b)) < 1000
        a, b = big(b), big(b + a)
        index += 1
    end

    return index
end


println("Time to evaluate Problem $(lpad(25, 3, "0")):")
@btime Problem25()
println("")
println("Result for Problem $(lpad(25, 3, "0")): ", Problem25())
