#!/usr/bin/env python
"""
Created on 26 Aug 2017

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 009 of Project Euler
https://projecteuler.net/problem=9
"""

from utils import timeit


@timeit("Problem 009")
def compute():
    """
    A Pythagorean triplet is a set of three natural numbers, a < b < c,
    for which a^2 + b^2 = c^2

    For example, 3^2 + 4^2 = 9 + 16 = 25 = 5^2.

    There exists exactly one Pythagorean triplet for which a + b + c = 1000.
    Find the product abc.
    """

    upper_limit = 1000
    for a in range(1, upper_limit + 1):
        for b in range(a + 1, upper_limit + 1):
            c = upper_limit - a - b
            if a * a + b * b == c * c:
                # It is now implied that b < c, because we have a > 0
                return a * b * c


if __name__ == "__main__":
    print(f"Result for Problem 009: {compute()}")
