#!/usr/bin/env python
"""
Created on 15 Sep 2018

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 020 of Project Euler
https://projecteuler.net/problem=20
"""

from math import factorial

from utils import timeit


@timeit("Problem 020")
def compute():
    """
    n! means n x (n - 1) x ... x 3 x 2 x 1

    For example, 10! = 10 x 9 x ... x 3 x 2 x 1 = 3628800,
    and the sum of the digits in the number 10! is:
    3 + 6 + 2 + 8 + 8 + 0 + 0 = 27.

    Find the sum of the digits in the number 100!
    """

    fact = factorial(100)
    ans = sum(int(digit) for digit in str(fact))

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 020: {compute()}")
