#!/usr/bin/env python
"""
Created on 15 Sep 2018

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 021 of Project Euler
https://projecteuler.net/problem=21
"""

from utils import timeit


def sum_divisors(n):
    return sum(i for i in range(1, n // 2 + 1) if n % i == 0)


@timeit("Problem 021")
def compute():
    """
    Let d(n) be defined as the sum of proper divisors of n (numbers
    less than n which divide evenly into n).
    If d(a) = b and d(b) = a, where a ≠ b, then a and b are an amicable
    pair and each of a and b are called amicable numbers.

    For example, the proper divisors of 220 are 1, 2, 4, 5, 10, 11, 20, 22,
    44, 55 and 110; therefore d(220) = 284. The proper divisors of 284 are
    1, 2, 4, 71 and 142; so d(284) = 220.

    Evaluate the sum of all the amicable numbers under 10000.
    """

    n = 10_000
    ans = 0
    for i in range(1, n):
        value = sum_divisors(i)
        if i != value and sum_divisors(value) == i:
            ans += i

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 021: {compute()}")
