#!/usr/bin/env python
"""
Created on 3 Jan 2020

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 029 of Project Euler
https://projecteuler.net/problem=29
"""
from itertools import product

from utils import timeit


@timeit("Problem 029")
def compute():
    """
    Consider all integer combinations of ab for 2 ≤ a ≤ 5 and 2 ≤ b ≤ 5:

        2^2=4, 2^3=8, 2^4=16, 2^5=32
        3^2=9, 3^3=27, 3^4=81, 3^5=243
        4^2=16, 4^3=64, 4^4=256, 4^5=1024
        5^2=25, 5^3=125, 5^4=625, 5^5=3125

    If they are then placed in numerical order, with any repeats removed, we
    get the following sequence of 15 distinct terms:

    4, 8, 9, 16, 25, 27, 32, 64, 81, 125, 243, 256, 625, 1024, 3125

    How many distinct terms are in the sequence generated by ab for 2≤a≤100
    and 2≤b≤100?
    """

    ans = len(set(a**b for a, b in product(range(2, 101), repeat=2)))

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 029: {compute()}")
