#!/usr/bin/env python
"""
Created on 02 Apr 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 034 of Project Euler
https://projecteuler.net/problem=34
"""

from math import factorial

from utils import timeit


@timeit("Problem 034")
def compute():
    """
    145 is a curious number, as 1! + 4! + 5! = 1 + 24 + 120 = 145.

    Find the sum of all numbers which are equal to the sum of the factorial
    of their digits.

    Note: As 1! = 1 and 2! = 2 are not sums they are not included.
    """

    ans = 0
    for num in range(10, 2_540_160):
        sum_of_factorial = 0
        for digit in str(num):
            sum_of_factorial += factorial(int(digit))
            if sum_of_factorial == num:
                ans += sum_of_factorial

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 034: {compute()}")
