#!/usr/bin/env python
"""
Created on 09 Apr 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 037 of Project Euler
https://projecteuler.net/problem=37
"""

from utils import is_prime, list_primes, timeit


def is_truncatable_prime(number):
    num_str = str(number)
    for i in range(1, len(num_str)):
        if not is_prime(int(num_str[i:])) or not is_prime(int(num_str[:-i])):
            return False
    return True


@timeit("Problem 037")
def compute():
    """
    The number 3797 has an interesting property. Being prime itself, it is
    possible to continuously remove digits from left to right, and remain
    prime at each stage: 3797, 797, 97, and 7.
    Similarly we can work from right to left: 3797, 379, 37, and 3.

    Find the sum of the only eleven primes that are both truncatable from left
    to right and right to left.

    NOTE: 2, 3, 5, and 7 are not considered to be truncatable primes.
    """

    ans = 0
    primes = list_primes(1_000_000)
    # Statement of the problem says this
    for number in primes[4:]:
        if is_truncatable_prime(number):
            ans += number

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 037: {compute()}")
