#!/usr/bin/env python
"""
Created on 12 Sep 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 048 of Project Euler
https://projecteuler.net/problem=48
"""

from utils import timeit


@timeit("Problem 048")
def compute():
    """
    The series, 1^1 + 2^2 + 3^3 + ... + 10^10 = 10405071317.

    Find the last ten digits of the series, 1^1 + 2^2 + 3^3 + ... + 1000^1000.
    """

    series = sum(i**i for i in range(1, 1001))
    ans = str(series)[-10:]

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 048: {compute()}")
