#!/usr/bin/env python
"""
Created on 18 Sep 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 050 of Project Euler
https://projecteuler.net/problem=50
"""

from utils import is_prime, list_primes, timeit


@timeit("Problem 050")
def compute():
    """
    The prime 41, can be written as the sum of six consecutive primes:

        41 = 2 + 3 + 5 + 7 + 11 + 13

    This is the longest sum of consecutive primes that adds to a prime below
    one-hundred.

    The longest sum of consecutive primes below one-thousand that adds to a
    prime, contains 21 terms, and is equal to 953.

    Which prime, below one-million, can be written as the sum of the most
    consecutive primes?
    """

    ans = 0
    result = 0
    prime_list = list_primes(1_000_000)

    for i in range(len(prime_list)):
        sum = 0
        count = 0
        for j in prime_list[i:]:
            sum += j
            count += 1
            if is_prime(sum) and count > result:
                result = count
                ans = sum
            if sum > 1_000_000:
                break

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 050: {compute()}")
